## dose3 7.0.0

=== Makefile ===

all: apps man

NAME=dose3
# make sure that generated tarballs are labeled according to the state of git
VERSION=$(shell git describe --tags --always --dirty)
DIST_DIR = $(NAME)-$(VERSION)
DIST_TARBALL = $(DIST_DIR).tar.gz

apps:
	@dune build

files=$(shell find src/ \( -name "*.ml" -o -name "*.mli"  -o -name "*.mlt" \) -not -path "src/experimental/*" -type f -print)

fmt:
	ocamlformat --enable-outside-detected-project --inplace ${files}

clean:
	@dune clean
	cd doc && $(MAKE) clean

test:
	@dune runtest

# stuff not not put in a distribution tarball
DIST_EXCLUDE = cudf tests $(wildcard */tests) experimental doc/webpages

INSTALL_STUFF_ = META
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.cma _build/doselibs/*.cmi)
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.cmxa _build/doselibs/*.cmxs)
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.a)
#INSTALL_STUFF_ += $(wildcard _build/*/*.mli)
INSTALL_STUFF_ += $(wildcard _build/rpm/*.so)

exclude_cudf = $(wildcard _build/doselibs/*cudf* _build/cudf/*)
INSTALL_STUFF = $(filter-out $(exclude_cudf), $(INSTALL_STUFF_))

installlib: META installcudf
	@test -d $(LIBDIR) || mkdir -p $(LIBDIR)
	@test -d $(LIBDIR)/stublibs || mkdir -p $(LIBDIR)/stublibs
	@$(INSTALL) -patch-version $(VERSION) $(NAME) $(INSTALL_STUFF)
	@echo "Install dose librairies to $(LIBDIR)"

install: installlib
	@cd _build/applications ; \
	install -d $(BINDIR) ; \
	for f in $$(ls *.$(OCAMLEXT)) ; do \
		install $(INSTALLOPTS) $$f $(BINDIR)/$${f%.$(OCAMLEXT)}$(EXE) ; \
	done
	@$(LN) $(BINDIR)/distcheck $(BINDIR)/debcheck$(EXE)
	@$(LN) $(BINDIR)/distcheck $(BINDIR)/rpmcheck$(EXE)
	@$(LN) $(BINDIR)/distcheck $(BINDIR)/eclipsecheck$(EXE)
	@echo "Install dose binaries to $(BINDIR)"

uninstalllib:
	@$(OCAMLFIND) remove -destdir $(LIBDIR) $(NAME)
	@echo "Uninstall dose librairies from $(LIBDIR)"

uninstall: uninstalllib uninstallcudf
	@for f in $$(ls *.$(OCAMLEXT)) ; do \
	  rm -f $(BINDIR)/$${f%.$(OCAMLEXT)}$(EXE) ; \
	done
	@rm -f $(BINDIR)/debcheck$(EXE) $(BINDIR)/rpmcheck$(EXE) $(BINDIR)/eclipsecheck$(EXE)
	@echo "Uninstall dose binaries from $(BINDIR)"

dist: ./$(DIST_TARBALL)
./$(DIST_TARBALL):
	@if [ -d ./$(DIST_DIR)/ ] ; then rm -rf ./$(DIST_DIR)/ ; fi
	@if [ -d ./$(DIST_TARBALL) ] ; then rm -f ./$(DIST_TARBALL) ; fi
	@mkdir ./$(DIST_DIR)/ ; git archive --format=tar HEAD | tar -x -C ./$(DIST_DIR)/
	@for f in $(DIST_EXCLUDE) ; do rm -rf ./$(DIST_DIR)/$$f; done
	@tar czf ./$(DIST_TARBALL) ./$(DIST_DIR)
	@rm -rf ./$(DIST_DIR)
	@echo "Distribution tarball: ./$(DIST_TARBALL)"

changelog:
	dch -c CHANGES --package $(NAME) -v $(VERSION)

credits:
	@git log --pretty=format:'%aN        %aE' | LC_ALL=C sort -u | awk -F'\t' '{printf("\t%s <%s>\n",$$1,$$2)}';

doc:
	dune build @doc
	$(MAKE) -C doc all

man:
	$(MAKE) -C doc/manpages

.PHONY: \
	common algo pef versioning debian rpm csw doseparseNoRpm doseparse \
	all clean top-level headers test tags install uninstall dist doc man

=== doc/Makefile ===
SUBDIRS=manpages debcheck.primer apt-external-solvers.primer

all: pages
	@for subdir in $(SUBDIRS); do \
	  $(MAKE) -C $$subdir; \
	done

clean:
	@for subdir in $(SUBDIRS); do \
	  $(MAKE) -C $$subdir clean; \
	done

manpages:
	$(MAKE) -C manpages

pages:
	$(MAKE) -C rtd

=== doc/apt-external-solvers.primer/Makefile ===
MAIN=apt-external-solvers

all: html pdf

html: $(MAIN).html
pdf: $(MAIN).pdf

$(MAIN).html:
	pandoc $(MAIN).md -o $(MAIN).html

$(MAIN).pdf:
	pandoc $(MAIN).md -o $(MAIN).pdf

clean:
	-rm -f $(MAIN).html $(MAIN).pdf

.phony: clean all pdf html

=== doc/debcheck.primer/Makefile ===
MAIN=debcheck-primer

all: html pdf

html: $(MAIN).html
pdf: $(MAIN).pdf

$(MAIN).html:
	pandoc $(MAIN).md -o $(MAIN).html

$(MAIN).pdf:
	pandoc $(MAIN).md -o $(MAIN).pdf

clean:
	-rm -f $(MAIN).html $(MAIN).pdf

.phony: clean all pdf html

=== doc/manpages/Makefile ===
# all pod files
PODA = $(wildcard *.pod)
# pod files per section
POD5 = apt-cudf.conf.pod
POD8 = apt-cudf-get.pod
POD1 = $(filter-out $(POD5) $(POD8),$(PODA))

# manpages to be generated
MAN1 = $(patsubst %.pod,%.1,$(POD1))
MAN5 = $(patsubst %.pod,%.5,$(POD5))
MAN8 = $(patsubst %.pod,%.8,$(POD8))
MANA = $(MAN1) $(MAN5) $(MAN8)

# manpages in HTML to be generated
HTMLA = $(patsubst %.pod,%.html,$(PODA))

all: man html

man: $(MANA)

html: $(HTMLA)

# we use pod2man and pod2html instead of pandoc because we want to be able to
# build this even on exotic platforms where pandoc is not available due to its
# very large number of build dependencies
%.1: %.pod
	pod2man --section 1 --center="DOSE Tools" \
		--release "$(NAME) $(VERSION)" $*.pod > $@

%.5: %.pod
	pod2man --section 5 --center="DOSE Tools" \
		--release "$(NAME) $(VERSION)" $*.pod > $@

%.8: %.pod
	pod2man --section 8 --center="DOSE Tools" \
		--release "$(NAME) $(VERSION)" $*.pod > $@

%.html: %.pod
	pod2html $*.pod > $@

distclean clean:
	rm -f $(MANA) $(HTMLA) pod2htmd.tmp pod2htmi.tmp

.PHONY: clean distclean man html all

=== debian/changelog ===
dose3 (7.0.0-6build2) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 30 Aug 2025 09:46:42 +0200

dose3 (7.0.0-6build1) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 17 Jun 2025 05:20:10 +0200

dose3 (7.0.0-6) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload

  [ Samuel Thibault ]
  * Add a noextra build profile (Closes: #1099685)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 08 Mar 2025 07:40:21 +0100

dose3 (7.0.0-5) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Add camlp-streams to debGrep dependencies

  [ Ralf Treinen ]
  * Update debian/watch, to follow recent gitlab change.

 -- Stéphane Glondu <glondu@debian.org>  Sat, 15 Jun 2024 07:33:35 +0200

dose3 (7.0.0-4) unstable; urgency=medium

  * Team upload
  * Fix tests with ocamlgraph 2.1.0 (Closes: #1051484)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 08 Sep 2023 17:55:57 +0200

dose3 (7.0.0-3) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Bump Standards-Version to 4.6.2

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)
  * Use secure URI in Homepage field
  * Set upstream metadata fields
  * Update standards version to 4.6.1

 -- Stéphane Glondu <glondu@debian.org>  Sat, 02 Sep 2023 08:45:28 +0200

dose3 (7.0.0-2) unstable; urgency=medium

  * Team upload
  * Fix build with recent dune

 -- Stéphane Glondu <glondu@debian.org>  Sat, 15 Jul 2023 06:48:32 +0200

dose3 (7.0.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Mon, 14 Feb 2022 11:47:12 +0100

dose3 (6.0.1-3) unstable; urgency=medium

  * Team upload
  * Fix compilation with ocamlgraph 2.0.0 (Closes: #1002498)
  * Bump Standards-Version to 4.6.0

 -- Stéphane Glondu <glondu@debian.org>  Fri, 24 Dec 2021 11:34:33 +0100

=== debian/control ===
Source: dose3
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stefano Zacchiroli <zack@debian.org>,
           Ralf Treinen <treinen@debian.org>,
           Johannes 'josch' Schauer <josch@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-ocaml,
               libbase64-ocaml-dev (>= 3.1.0),
               libbz2-ocaml-dev (>= 0.6.0-10~) <!pkg.dose3.noextra>,
               libcudf-ocaml-dev,
               libextlib-ocaml-dev (>= 1.7.7),
               libocamlgraph-ocaml-dev (>= 2.1.0),
               libre-ocaml-dev,
               libzip-ocaml-dev (>= 1.08) <!pkg.dose3.noextra>,
               ocaml-dune (>= 2.7.1),
               ocaml,
               pandoc
Build-Depends-Arch: grep-dctrl <!nocheck>,
                    libounit-ocaml-dev <!nocheck>,
                    libcamlp-streams-ocaml-dev <!nocheck>,
                    libparmap-ocaml-dev <!pkg.dose3.noextra>,
                    perl,
                    python3-yaml <!nocheck>,
                    xz-utils <!nocheck>
Build-Depends-Indep: graphviz <!nodoc>,
                     hevea <!nodoc>,
                     lmodern <!nodoc>,
                     ocaml-odoc <!nodoc>,
                     texlive-latex-base <!nodoc>,
                     texlive-latex-extra <!nodoc>
Standards-Version: 4.6.2
Homepage: https://www.mancoosi.org/software/
Vcs-Browser: https://salsa.debian.org/ocaml-team/dose3
Vcs-Git: https://salsa.debian.org/ocaml-team/dose3.git
Rules-Requires-Root: no

Package: libdose3-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Recommends: ocaml-findlib
Provides: ${ocaml:Provides}
Description: OCaml libraries for package dependencies (development files)
 Dose3 is a framework consisting of several OCaml libraries for analysing
 the metadata of software packages (like Packages files of Debian suites).
 .
 Though not tied to any particular distribution, Dose3 constitutes a
 pool of libraries which enable analyzing packages coming from various
 distributions.
 .
 Besides basic functionalities for querying and setting package
 properties, dose3 also implements algorithms for solving more complex
 problems (monitoring package evolutions, correct and complete
 dependency resolution, repository-wide uninstallability checks).
 .
 This package contains the development stuff you need to use dose3 for
 the development of programs.

Package: dose-distcheck
Section: devel
Architecture: any
Build-Profiles: <!pkg.dose3.noextra>
Depends: xz-utils, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Breaks: dose3-distcheck (<< 2.9.13)
Replaces: dose3-distcheck (<< 2.9.13)
Description: Checks whether dependencies of packages can be satisfied
 This software checks for every package of a distribution whether it
 is possible to satisfy its dependencies and conflicts within this
 distribution. It comes in several versions:
  - dose-debcheck for Debian packages
  - dose-rpmcheck for rpm packages
  - dose-eclipsecheck for OSGi plugins

Package: dose-builddebcheck
Section: devel
Architecture: any
Build-Profiles: <!pkg.dose3.noextra>
Depends: xz-utils, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Breaks: dose3-builddebcheck (<< 2.9.13)
Replaces: dose3-builddebcheck (<< 2.9.13)
Description: Checks whether build-dependencies can be satisfied
 This software checks, given a collection of source package stanzas
 and a collection of binary package stanzas of Debian packages, whether
 the build-dependencies of each source package can be satisfied by the
 binary packages.

Package: dose-extra
Section: devel
Architecture: any
Build-Profiles: <!pkg.dose3.noextra>
Provides: ceve
Breaks: ceve (<< 2.9.10)
Replaces: ceve (<< 2.9.10)
Depends: xz-utils, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Description: Extra QA tools from the Dose3-library
 This package contains extra tools for analyzing meta-data of software
 packages:
  - ceve, a general metadata parser supporting different input formats
    (Debian, rpm, and others) and different output formats.
  - dose-outdated, a Debian-specific tool for finding packages that are not
    installable with respect to a package repository, and that can only be
    made installable again by fixing the package itself.
  - dose-challenged, a Debian-specific tool for checking which packages
    will certainly become uninstallable when some existing package is upgraded
    to a newer version.
  - dose-deb-coinstall, a Debian-specific tool for checking whether a set of
    packages can be installed all together.
 The tools dose-distcheck and dose-builddebcheck are packaged in their
 own respective packages.

Package: apt-cudf
Section: admin
Architecture: any
Build-Profiles: <!pkg.dose3.noextra>
Depends: aspcud | cudf-solver,
         ${misc:Depends},
         ${ocaml:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Description: CUDF solver integration for APT
 apt-cudf provides integration among the APT package manager and CUDF solvers,
 allowing APT to rely on external (CUDF-based) dependency solvers to plan
 package installation, upgrade, and removal.
 .
 CUDF is a distribution-independent, standard format to describe dependency
 solving scenarios, as faced by package managers in popular package-based
 GNU/Linux distributions. APT is a well-known package manager for Debian-based
 distributions, which is able to delegate dependency solving to external
 solvers, by the means of the External Dependency Solving Protocol (EDSP).
 .
 apt-cudf provides the glue between the EDSP protocol and CUDF solvers,
 enabling any installed CUDF solver to be used as an external solver for APT.
 .
 Several CUDF solvers are available in Debian. They all provide the cudf-solver
 virtual package.

Package: dose-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Description: Documentation for dose tools and libraries.
 The dose suite provides libraries for handling package meta-data, and various
 tools for analyzing package relationships in a large package repository.
 This package contains the documentation of the dose API, and tutorials of
 various dose tools.

=== debian/watch ===
version=4

opts="searchmode=plain" \
 https://gitlab.com/irill/@PACKAGE@/tags?sort=updated_desc \
 -/archive/\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
